# coding: utf-8
import sys
from tkinter import *
from imagecanvas import *

#■ガンマ補正処理
def GammaCorrection():
    NX=bitmap.info.width
    NY=bitmap.info.height
    gamma=scale1.get()
    DX=int(NX/20)   # "処理中"を表示する間隔
    K=1
    for i in range(NX):
        if (i % DX)==0:
            root.title("ガンマ補正処理中"+"■"*K)
            K+=1
        for j in range(NY):
            R=int(255*pow(tmp[i][j][0]/255,gamma))
            G=int(255*pow(tmp[i][j][1]/255,gamma))
            B=int(255*pow(tmp[i][j][2]/255,gamma))
            cbit.Canvas.itemconfig(cbit.ID[i][j],fill=RGB(R,G,B))
    root.update()
    root.title("ガンマ補正完了")
    
#■近似曲線のグラフを描く
def drawGraph(gamma):
    canvas3.delete("線")
    X1=0
    Y1=0
    for i in range(100):
        X2=X1+0.01
        Y2=pow(X2,gamma)
        canvas3.create_line(X1*100+5, 105-Y1*100, X2*100+5,105-Y2*100,
                            fill='#FF0000', width=1, tag="線")
        X1=X2
        Y1=Y2
        
#■スケールが移動されたときの処理
def gammaDsp(n):
    drawGraph(scale1.get())
            
#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy()
        sys.exit()

#■メイン処理   
root = Tk()
root.geometry("600x500")
root.title("ガンマ補正")
FT=[('BMPファイルlファイル','*.bmp;*.*')]
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    root.title("ビットマップ読込み中")
    bitmap=readBitmap(filename)
    if bitmap!=[]:
        #準備処理
        root.title("キャンバス準備中")
        canvas=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas.place(x=0,y=30)
        canvas2=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas2.place(x=bitmap.info.width,y=30)
        canvas3=Canvas(root,width=110,height=110)
        canvas3.place(x=320,y=380)
        
        root.title("ビットマップ表示中")
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        root.title("元画像ビットマップ表示中")
        c2=drawBitmap(canvas2, bitmap)
        root.update()
        
        root.title("ビットマップリスト準備中")
        tmp=getRGBList(cbit)
        root.title("ガンマ補正")
       
        #ラベルの宣言
        label1 = Label(root, text='処理後', fg='black')
        label1.place(x=10, y=2)
        label2 = Label(root, text='元画像', fg='black')
        label2.place(x=bitmap.info.width+10, y=2)
        label3 = Label(root, text='近似曲線' , fg='#000000')
        label3.place(x=260,y=380)

        #スケールの宣言
        scale1 = Scale(root, label='γ', resolution=0.01,length=200,
                       orient='h', from_=0, to=5,
                       command=gammaDsp)
        scale1.place(x=110,y=400)
        scale1.set(1.0)
        
        #グラフ表示
        canvas3.create_rectangle(5,5,105,105,outline="#0000FF")
        gammaDsp(1)
       
        #ボタンの宣言                        
        button1 = Button(root, text='終了', command=exitProc)
        button1.place(x=500, y=400)
        button2 = Button(root, text='ガンマ補正', command=GammaCorrection)
        button2.place(x=10, y=400)
        
        #メインループ("WM_DELETE_WINDOW"が届いたときexitProcを呼び出す)
        root.protocol("WM_DELETE_WINDOW",exitProc)
        root.mainloop()
root.destroy()
sys.exit()
        
